// Code generated by mockery v2.12.1. DO NOT EDIT.

package mocks

import (
	dao "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dao"
	dto "gitlab.informatika.org/rahmahkn/if3250_2022_03_ensiklo/internal/app/model/dto"

	mock "github.com/stretchr/testify/mock"

	testing "testing"
)

// CategoryService is an autogenerated mock type for the CategoryService type
type CategoryService struct {
	mock.Mock
}

// CreateCategory provides a mock function with given fields: category
func (_m *CategoryService) CreateCategory(category dto.CreateCategoryRequestDTO) (dao.Category, error) {
	ret := _m.Called(category)

	var r0 dao.Category
	if rf, ok := ret.Get(0).(func(dto.CreateCategoryRequestDTO) dao.Category); ok {
		r0 = rf(category)
	} else {
		r0 = ret.Get(0).(dao.Category)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dto.CreateCategoryRequestDTO) error); ok {
		r1 = rf(category)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteCategory provides a mock function with given fields: categoryId
func (_m *CategoryService) DeleteCategory(categoryId dto.DeleteCategoryRequestDTO) error {
	ret := _m.Called(categoryId)

	var r0 error
	if rf, ok := ret.Get(0).(func(dto.DeleteCategoryRequestDTO) error); ok {
		r0 = rf(categoryId)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetAllCategory provides a mock function with given fields:
func (_m *CategoryService) GetAllCategory() ([]dto.CategoryDTO, error) {
	ret := _m.Called()

	var r0 []dto.CategoryDTO
	if rf, ok := ret.Get(0).(func() []dto.CategoryDTO); ok {
		r0 = rf()
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]dto.CategoryDTO)
		}
	}

	var r1 error
	if rf, ok := ret.Get(1).(func() error); ok {
		r1 = rf()
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetCategory provides a mock function with given fields: id
func (_m *CategoryService) GetCategory(id uint64) (dto.CategoryDTO, error) {
	ret := _m.Called(id)

	var r0 dto.CategoryDTO
	if rf, ok := ret.Get(0).(func(uint64) dto.CategoryDTO); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(dto.CategoryDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(uint64) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateCategory provides a mock function with given fields: newCategory
func (_m *CategoryService) UpdateCategory(newCategory dto.CategoryDTO) (dto.CategoryDTO, error) {
	ret := _m.Called(newCategory)

	var r0 dto.CategoryDTO
	if rf, ok := ret.Get(0).(func(dto.CategoryDTO) dto.CategoryDTO); ok {
		r0 = rf(newCategory)
	} else {
		r0 = ret.Get(0).(dto.CategoryDTO)
	}

	var r1 error
	if rf, ok := ret.Get(1).(func(dto.CategoryDTO) error); ok {
		r1 = rf(newCategory)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewCategoryService creates a new instance of CategoryService. It also registers the testing.TB interface on the mock and a cleanup function to assert the mocks expectations.
func NewCategoryService(t testing.TB) *CategoryService {
	mock := &CategoryService{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
